#iff.g
#iffILBM.g

uint
    WIDTH = 320,
    MOD_WIDTH = (WIDTH + 15) / 16,
    HEIGHT = 100,
    DEPTH = 5,
    SIZE = MOD_WIDTH * 16 * HEIGHT * DEPTH / 8;

[DEPTH, HEIGHT, MOD_WIDTH] uint Data;

proc main()void:
    [4] char MESS1 = ('F', 'O', 'R', 'M');
    [8] char MESS2 = ('I', 'L', 'B', 'M', 'B', 'M', 'H', 'D');
    [4] char MESS3 = ('B', 'O', 'D', 'Y');
    channel output binary chout;
    channel input binary chin;
    file() fout, fin;
    BitMapHeader_t bmh;
    ulong count;
    register uint i, j, k;
    byte b;

    if not open(chin, fin, "raw.in") then
	writeln("Can't open 'raw.in'");
	return;
    fi;
    if not open(chout, fout, "raw.ilbm") then
	writeln("Can't open 'raw.ilbm'");
	close(chin);
	return;
    fi;
    write(chout; MESS1);
    count := 20 + SIZE + (sizeof(BitMapHeader_t) + 1) / 2 * 2;
    write(chout; count);
    write(chout; MESS2);
    count := (sizeof(BitMapHeader_t) + 1) / 2 * 2;
    write(chout; count);
    bmh := BitMapHeader_t(
	WIDTH, HEIGHT, 0, 0, DEPTH, bmsk_none, bcmp_none,
	0, 0, 0, 0, WIDTH, 200
    );
    write(chout; bmh);
    write(chout; MESS3);
    count := SIZE;
    write(chout; count);
    for i from 0 upto DEPTH - 1 do
	for j from 0 upto HEIGHT - 1 do
	    for k from 0 upto MOD_WIDTH - 1 do
		read(chin; Data[i, j, k]);
	    od;
	od;
    od;
    for i from 0 upto HEIGHT - 1 do
	for j from 0 upto DEPTH - 1 do
	    for k from 0 upto MOD_WIDTH - 1 do
		write(chout; Data[j, i, k]);
	    od;
	od;
    od;
    close(chout);
    close(chin);
corp;
